<template lang="pug">
  label.b-datepicker(
    :class=`{
      'b-datepicker--is-filled': !!date,
      'b-datepicker--error': errorMessage.length !== 0,
    }`
  )
    span.b-datepicker__label {{label}}
    date-picker(
      v-model="date"
      :format="format"
      lang="ru"
      input-class="b-datepicker__input"
      :type="type"
      :placeholder="placeholder"
      :popupStyle="popupStyle"
      @input="event"
      @blur="event"
    )
    .b-datepicker__wrapper
      .b-datepicker__error(v-for="error in errorMessage")
        span.b-datepicker__error-message {{error}}
</template>

<script>
import moment from 'moment';
import DatePicker from 'vue2-datepicker';

export default {
  name: 'DatePickerTwo',
  props: {
    label: {
      type: String,
      default: '',
    },
    type: {
      type: String,
      default: 'date',
    },
    placeholder: {
      type: String,
      default: '',
    },
    format: {
      type: String,
      default: 'DD.MM.YYYY',
    },
    defaultValue: {
      type: Object,
    },
    errorMessage: {
      type: Array,
      default: [],
    },
  },
  components: {
    DatePicker,
  },
  data() {
    return {
      date: '',
      popupStyle: {
        top: '58px',
        left: '0px',
      },
    };
  },
  mounted() {
    this.date = moment(this.defaultValue, 'DD.MM.YYYY');
  },
  computed: {
    defaultDate() {
      return this.defaultValue !== ''
        ? moment(this.defaultValue, 'DD.MM.YYYY')
        : new Date();
    },
  },
  watch: {
    date() {
      this.$emit('input', this.date);
    },
  },
  methods: {
    event() {
      this.$emit('input', this.date);
    },
  },
};
</script>

<style lang="scss">
@import '@/assets/styles/additional/_variables.scss';
@import '@/blocks/datepicker/datepicker.scss';
</style>
